import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class kwillis_pong2 extends PApplet {

PongBall ball;
PongPaddleUser myPaddle;
PongPaddleBot theirPaddle;

public void setup(){
  size(600, 600);
  rectMode(CENTER_RADIUS);
  ellipseMode(CENTER_RADIUS);
  noStroke();
  smooth();
  myPaddle = new PongPaddleUser(width - PongPaddle.width * 2, height / 2);
  theirPaddle = new PongPaddleBot(PongPaddle.width * 2, height / 2);
  ball = new PongBall(myPaddle, theirPaddle, width / 2, height / 2);
}

public void draw(){
  background(0);
  ball.draw();
  myPaddle.draw();
  theirPaddle.draw();  
}
class PongBall{
  PongPaddleBot theirPaddle;
  PongPaddleUser myPaddle;
  float x, y;
  static final int diameter = 10;
  float velocityX = random(2, 3);
  float velocityY = random(2, 3);

  PongBall(PongPaddleUser myPaddle, PongPaddleBot theirPaddle, int x, int y){
    this.myPaddle = myPaddle;
    this.theirPaddle = theirPaddle;
    this.x = x;
    this.y = y;
  }

  public void draw(){
    update();
    ellipse(x, y, diameter, diameter);
  }

  public void update(){

    x += velocityX;
    y += velocityY;
    
    // Check for collisions
    if(myPaddle.isInside(this)){
      velocityX *= -1F;
    } else if(theirPaddle.isInside(this)){
      velocityX *= -1F;
    }

    // Bounce the ball
    if (x <= 0 + diameter ){
      x = diameter;
      velocityX *= -1F;
    } else if (x >= width - diameter){
      x = width - diameter;
      velocityX *= -1F;
    }

    if (y <= diameter){
      y = diameter;
      velocityY *= -1;
    } else if (y >= height - diameter){
      y = height - diameter;
      velocityY *= -1F;
    }
  }

}



abstract class PongPaddle{
   int x, y;
   static final int width = 5;
   static final int height = 100;
   
   PongPaddle(int x, int y){
     this.x = x;
     this.y = y;
  }
  
   public void draw(){
    fill(200);
    rect(x, y, width, height);
  }
 
}

class PongPaddleBot extends PongPaddle {

  PongPaddleBot(int x, int y){
    super(x, y);
  }

  public boolean isInside(PongBall ball){
    this.y = (int)ball.y;
    if (ball.x - ball.diameter/2 >= this.x && ball.x - ball.diameter/2 <= x + this.width) {
      return true;
    } 
    else {
      return false;
    }
  }

}

class PongPaddleUser extends PongPaddle {

  PongPaddleUser(int x, int y){
    super(x, y);
  }

  public boolean isInside(PongBall ball){
    this.y = mouseY;
    if (ball.x + ball.diameter >= this.x && ball.x + ball.diameter <= x + this.width) {
      return true;
    } else {
      return false;
    }
  }

}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "kwillis_pong2" });
  }
}
